Name: file
Version: 5.32
Release: 4
License: BSD
Summary: file
Url: http://www.darwinsys.com/file/
Requires: file-magic = %{version}


BuildRequires: autoconf
BuildRequires: automake
BuildRequires: libtool

BuildRequires: zlib-devel

Source0: ftp://ftp.astron.com/pub/file/file-%{version}.tar.gz

Patch0: file-aix-hang.patch


%description
The file command is "a file type guesser", that is, a command-line tool that tells you in words what kind of data a file contains. Unlike most GUI systems, command-line UNIX systems - with this program leading the charge - don't rely on filename extentions to tell you the type of a file, but look at the file's actual contents. This is, of course, more reliable, but requires a bit of I/O.

%package -n libmagic1
Summary: file library
Requires: file-magic = %{version}

%description -n libmagic1
The file command is "a file type guesser", that is, a command-line tool that tells you in words what kind of data a file contains. Unlike most GUI systems, command-line UNIX systems - with this program leading the charge - don't rely on filename extentions to tell you the type of a file, but look at the file's actual contents. This is, of course, more reliable, but requires a bit of I/O.

%package magic
Summary: file development files

%description magic
The file command is "a file type guesser", that is, a command-line tool that tells you in words what kind of data a file contains. Unlike most GUI systems, command-line UNIX systems - with this program leading the charge - don't rely on filename extentions to tell you the type of a file, but look at the file's actual contents. This is, of course, more reliable, but requires a bit of I/O.

%package devel
Summary: file development files
Requires: libmagic1 = %{version}

%description devel
The file command is "a file type guesser", that is, a command-line tool that tells you in words what kind of data a file contains. Unlike most GUI systems, command-line UNIX systems - with this program leading the charge - don't rely on filename extentions to tell you the type of a file, but look at the file's actual contents. This is, of course, more reliable, but requires a bit of I/O.

%prep
%setup -q

%patch0 -p1

%build

autoreconf -fi

%configure \
  LDFLAGS="-Wl,-blibpath:%{_libdir}:/QOpenSys/usr/lib" \
  --with-aix-soname=svr4 \
  --enable-shared \
  --disable-static \
  --disable-nls

# https://stackoverflow.com/a/12080251/3245633
# This can cause an infinite loop as strndup overwrites random memory with 0s
# which may overwrite the ml->next pointer, causing the loop condition to never
# be hit in file_softmagic:
# for (ml = ms->mlist[0]->next; ml != ms->mlist[0]; ml = ml->next)
# ms->mlist[0] = 0x20003070
# ml = 0x20003130, ml->next = 0x20003070
# ...
# strndup("", 51k)
# ml = 0x20003130, ml->next = 0x0
# ml = ml->next
# ml == ms->mlist[0] ? FALSE
perl -p -i -e 's|#define HAVE_STRNDUP 1|/* #undef HAVE_STRNDUP */|' config.h

%make_build

%install

%make_install

rm %{buildroot}/%{_libdir}/*.la || :

%files
%defattr(-, qsys, *none)

%{_bindir}/file
%{_mandir}/man1/file.1


%files -n libmagic1
%defattr(-, qsys, *none)

%{_libdir}/libmagic.so.1*


%files magic
%defattr(-, qsys, *none)

%{_datadir}/misc/magic.mgc
%{_mandir}/man4/magic.4


%files devel
%defattr(-, qsys, *none)

%{_libdir}/libmagic.so
%{_mandir}/man3/libmagic.3
%{_includedir}/magic.h

%changelog
